module Yorinter
  class PdfEngine < Engine
    def build_engine
      @engine   = WickedPdf.new
    end
  end

  class HtmlToPdfEngine < PdfEngine
    register_engine 'html', 'pdf'

    def render
      @engine.pdf_from_string(@document.template, document_options)
    end
  end

  class ErbToPdfEngine < PdfEngine
    register_engine 'erb', 'pdf'

    def render
      html = ErbEngine.new(@document, @params, @options).render
      @engine.pdf_from_string(html, document_options)
    end
  end

  class HamlToPdfEngine < PdfEngine
    register_engine 'haml', 'pdf'

    def render
      html = HamlEngine.new(@document, @params, @options).render
      @engine.pdf_from_string(html, document_options)
    end
  end
end
