module Yorinter
  class PrintableDocument
    include Yorinter::Printable

    def initialize params = {}
      [:name, :code, :version, :template, :helper, :style,
        :model, :model_endpoint, :binding_object,
        :input_format, :output_format, :options].each do |field|
        send("#{field}=".to_sym, params[field]) if params[field]
      end
    end

    def render engine, params = {}, options = {}
      engine.new(self, params, options).render
    end

    attr_accessor :name
    attr_accessor :code
    attr_accessor :version
    attr_accessor :template
    attr_accessor :helper
    attr_accessor :style
    attr_accessor :model
    attr_accessor :model_endpoint
    attr_accessor :input_format
    attr_accessor :output_format
    attr_accessor :options
    attr_accessor :binding_object
  end
end
